function Tile(position, value, type = "grade") {
  this.x                = position.x;
  this.y                = position.y;
  this.value            = value;
  this.type             = type;

  this.previousPosition = null;
  this.mergedFrom       = null; // Tracks tiles that merged together
}

Tile.prototype.savePosition = function () {
  this.previousPosition = { x: this.x, y: this.y };
};

Tile.prototype.updatePosition = function (position) {
  this.x = position.x;
  this.y = position.y;
};

Tile.prototype.serialize = function () {
  return {
    position: {
      x: this.x,
      y: this.y
    },
    value: this.value,
    type: this.type
  };
};

Tile.prototype.canMerge = function (other) {
  if (this.type == "W" || other.type == "W") {
    return true;
  }
  if (this.type == "P" && other.type == "P") {
    return true;
  }
  if (this.type == "grade" && other.type == "grade" && this.value != 2048 && this.value === other.value) {
    return true;
  }
  if (this.type == "grade" && this.value != 2048 && other.type == "EX") {
    return true;
  }
  if (other.type == "grade" && other.value != 2048 && this.type == "EX") {
    return true;
  }
  if (this.type == "grade" && this.value != 2 && other.type == "F") {
    return true;
  }
  if (other.type == "grade" && other.value != 2 && this.type == "F") {
    return true;
  }
  return false;
}
